# Avoid running unnecessary services on the Sidekiq server
gitaly['enable'] = false
postgresql['enable'] = false
redis['enable'] = false
puma['enable'] = false
gitlab_workhorse['enable'] = false
prometheus['enable'] = false
alertmanager['enable'] = false
grafana['enable'] = false
gitlab_exporter['enable'] = false
nginx['enable'] = false
gitlab_kas['enable'] = false

external_url '{{ external_url_sanitised }}'

# Sidekiq Config
sidekiq['enable'] = true
sidekiq['listen_address'] = '0.0.0.0'
sidekiq['max_concurrency'] = {{ sidekiq_max_concurrency }}
sidekiq['queue_groups'] = [
{% for cpu in range(ansible_processor_vcpus) %}
  "*",
{% endfor %}
]

# Ensure UIDs and GIDs match between servers for permissions
user['uid'] = 9000
user['gid'] = 9000
web_server['uid'] = 9001
web_server['gid'] = 9001

{% if 'consul' in groups %}
# Consul Agent (Monitoring Auto Discovery)
consul['enable'] = true
consul['configuration'] = {
  bind_addr: '{{ ansible_default_ipv4.address }}',
  retry_join: %w({{ (consul_int_addrs | join(' ')) }})
}
consul['monitoring_service_discovery'] = true
{% endif %}

node_exporter['listen_address'] = '0.0.0.0:9100'

# Storage Config
## Object Storage - consolidated object storage configuration

{% if gitlab_object_storage_type == 'object_storage' and cloud_provider != 'none' %}
gitlab_rails['object_store']['enabled'] = true

### Provider-specific connection settings
gitlab_rails['object_store']['connection'] = {
  {{ lookup('template', 'object_storage/' + cloud_provider + '.rb.j2') | indent(width=2) }}
}

gitlab_rails['object_store']['objects']['artifacts']['bucket'] = "{{ gitlab_object_storage_artifacts_bucket }}"
gitlab_rails['object_store']['objects']['dependency_proxy']['bucket'] = "{{ gitlab_object_storage_dependency_proxy_bucket }}"
gitlab_rails['object_store']['objects']['external_diffs']['bucket'] = "{{ gitlab_object_storage_external_diffs_bucket }}"
gitlab_rails['object_store']['objects']['lfs']['bucket'] = "{{ gitlab_object_storage_lfs_bucket }}"
gitlab_rails['object_store']['objects']['packages']['bucket'] = "{{ gitlab_object_storage_packages_bucket }}"
gitlab_rails['object_store']['objects']['terraform_state']['bucket'] = "{{ gitlab_object_storage_terraform_state_bucket }}"
gitlab_rails['object_store']['objects']['uploads']['bucket'] = "{{ gitlab_object_storage_uploads_bucket }}"

## Object Storage - separated backups storage
gitlab_rails['backup_upload_connection'] = {
  {{ lookup('template', 'object_storage/' + cloud_provider + '.rb.j2') | indent(width=2) }}
}
gitlab_rails['backup_upload_remote_directory'] = "{{ gitlab_object_storage_backups_bucket }}"
{% elif 'gitlab_nfs' in groups and gitlab_object_storage_type == 'nfs' %}

## NFS - Objects
gitlab_rails['uploads_directory'] = '{{ gitlab_nfs_path }}/uploads'
gitlab_rails['shared_path'] = '{{ gitlab_nfs_path }}/shared'
gitlab_ci['builds_directory'] = '{{ gitlab_nfs_path }}/builds'
{% endif %}

# Components Config
# Redis
{% if redis_external %}
## Redis Non Omnibus (PaaS \ User Provided)
### Combined Queues
gitlab_rails['redis_host'] = '{{ redis_host }}'
gitlab_rails['redis_port'] = '{{ redis_port }}'
gitlab_rails['redis_password'] = '{{ redis_password }}'
gitlab_rails['redis_ssl'] = {{ redis_external_ssl | lower }}
gitlab_rails['redis_enable_client'] = {{ redis_external_enable_client | lower }}

{% elif redis_cache_external and redis_persistent_external %}
### Separate Queues
#### Default
gitlab_rails['redis_host'] = '{{ redis_persistent_host }}'
gitlab_rails['redis_port'] = '{{ redis_persistent_port }}'
gitlab_rails['redis_password'] = '{{ redis_persistent_password }}'
gitlab_rails['redis_ssl'] = {{ redis_persistent_external_ssl | lower }}

#### Cache
gitlab_rails['redis_cache_instance'] = '{{ "rediss" if redis_cache_external_ssl else "redis" }}://:{{ redis_cache_password}}@{{ redis_cache_host }}:{{ redis_cache_port }}'

{% elif 'redis' in groups %}
## Redis Omnibus - Separate Node(s)
### Single Node - Combined Queues
{% if groups['redis'] | length == 1 %}
gitlab_rails['redis_port'] = '{{ redis_port }}'
gitlab_rails['redis_host'] = '{{ redis_host }}'
gitlab_rails['redis_password'] = '{{ redis_password }}'

{% elif groups['redis'] | length > 1 %}
### Multi Node - Combined Queues
redis['master_name'] = 'gitlab-redis'
redis['master_password'] = '{{ redis_password }}'

gitlab_rails['redis_sentinels'] = [
{% for ip in redis_int_addrs %}
  {host: '{{ ip }}', port: {{ redis_sentinel_port }}},
{% endfor %}
]
{% endif %}

{% elif 'redis_cache' in groups and 'redis_persistent' in groups %}
### Multi Node - Separate Queues
#### Default
redis['master_name'] = 'gitlab-redis-persistent'
redis['master_password'] = '{{ redis_persistent_password }}'

gitlab_rails['redis_sentinels'] = [
{% for ip in redis_persistent_int_addrs %}
  {host: '{{ ip }}', port: {{ redis_sentinel_port }}},
{% endfor %}
]

#### Cache
gitlab_rails['redis_cache_instance'] = 'redis://:{{ redis_cache_password }}@gitlab-redis-cache'
gitlab_rails['redis_cache_sentinels'] = [
{% for ip in redis_cache_int_addrs %}
  {host: '{{ ip }}', port: {{ redis_sentinel_port }}},
{% endfor %}
]
{% endif %}

# Postgres \ Database
{% if postgres_external %}
gitlab_rails['db_host'] = '{{ postgres_host }}'
gitlab_rails['db_port'] = '{{ postgres_port }}'
gitlab_rails['db_username'] = '{{ postgres_username }}'
gitlab_rails['db_password'] = '{{ postgres_password }}'
gitlab_rails['db_database'] = '{{ postgres_database_name }}'

{% if postgres_load_balancing_hosts | length > 0 and not (gitlab_version != '' and gitlab_version is version('14.1', '<')) %}
gitlab_rails['db_load_balancing'] = { 'hosts' => {{ postgres_load_balancing_hosts }} }
{% endif %}

{% elif 'postgres' in groups %}
gitlab_rails['db_host'] = '{{ internal_lb_host }}'
gitlab_rails['db_port'] = 6432
gitlab_rails['db_password'] = '{{ postgres_password }}'

{% if groups['postgres'] | length > 1 %}
gitlab_rails['db_load_balancing'] = { 'hosts' => {{ postgres_int_addrs }} }
{% endif %}

{% endif %}

gitlab_rails['auto_migrate'] = false

gitlab_rails['env'] = {
  # Sidekiq Memory Killer - Disabled by default due to https://gitlab.com/gitlab-org/gitlab/-/issues/225909
  "SIDEKIQ_MEMORY_KILLER_MAX_RSS" => {{ sidekiq_memory_killer_max_rss }}
}

# Gitaly
{% if 'praefect' in groups %}
## Gitaly Cluster - Separate Node(s)
gitaly['enable'] = false
git_data_dirs({
  "default" => {
    "gitaly_address" => "{{ 'tls' if praefect_ssl else 'tcp' }}://{{ internal_lb_host }}:{{ praefect_ssl_port if gitaly_ssl else '2305' }}",
    "gitaly_token" => '{{ praefect_external_token }}'
  }
})
{% elif 'gitaly' in groups %}
## Gitaly - Separate Node(s)
gitaly['enable'] = false
gitlab_rails['gitaly_token'] = '{{ gitaly_token }}'

git_data_dirs({
  'default' => { 'gitaly_address' => "{{ 'tls' if gitaly_ssl else 'tcp' }}://{{ gitaly_primary_int_addr }}:{{ gitaly_ssl_port if gitaly_ssl else '8075' }}" },
  'storage1' => { 'gitaly_address' => "{{ 'tls' if gitaly_ssl else 'tcp' }}://{{ gitaly_primary_int_addr }}:{{ gitaly_ssl_port if gitaly_ssl else '8075' }}" },
{% for gitaly_secondary_ip in gitaly_secondary_int_addrs %}
  "storage{{loop.index + 1}}" => { 'gitaly_address' => "{{ 'tls' if gitaly_ssl else 'tcp' }}://{{ gitaly_secondary_ip }}:{{ gitaly_ssl_port if gitaly_ssl else '8075' }}" },
{% endfor %}
})
{% endif %}

{% if container_registry_enable %}
registry_external_url "{{ container_registry_external_url }}"
{% endif %}

geo_confs = Dir.glob(File.join("/etc/gitlab/", "gitlab.geo.*.rb"))
geo_confs.each { |conf|
  from_file conf
}

custom_confs = Dir.glob(File.join("/etc/gitlab/", "gitlab.sidekiq.*.rb"))
custom_confs.each { |conf|
  from_file conf
}
